declare enum PageOptions {
    ALL = "ALL",
    FIRST = "FIRST",
    LAST = "LAST",
    FIRST_AND_LAST = "FIRST_AND_LAST"
}
declare class DocumentOcr {
    apiKey: string;
    model: string;
    standardFontDataUrl: string;
    debug: boolean;
    constructor({ apiKey, model, standardFontDataUrl, debug, }: {
        apiKey?: string;
        model?: "gpt-4-turbo" | "gpt-4-vision-preview" | "claude-3-opus-20240229" | "claude-3-sonnet-20240229" | "claude-3-haiku-20240307";
        standardFontDataUrl?: string;
        debug?: boolean;
    });
    process: ({ document, mimeType, prompt, pageOptions, multiplePasses, }: {
        document: string | Buffer;
        mimeType: "image/png" | "image/jpeg" | "image/jpg" | "image/webp" | "image/gif" | "application/pdf";
        prompt: string;
        pageOptions?: PageOptions | undefined;
        multiplePasses?: boolean | undefined;
    }) => Promise<any>;
}

export { DocumentOcr, PageOptions };
