"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __knownSymbol = (name, symbol) => {
  if (symbol = Symbol[name])
    return symbol;
  throw Error("Symbol." + name + " is not defined");
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
var __forAwait = (obj, it, method) => (it = obj[__knownSymbol("asyncIterator")]) ? it.call(obj) : (obj = obj[__knownSymbol("iterator")](), it = {}, method = (key, fn) => (fn = obj[key]) && (it[key] = (arg) => new Promise((yes, no, done) => (arg = fn.call(obj, arg), done = arg.done, Promise.resolve(arg.value).then((value) => yes({ value, done }), no)))), method("next"), method("return"), it);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  DocumentOcr: () => DocumentOcr,
  PageOptions: () => PageOptions
});
module.exports = __toCommonJS(src_exports);
var import_sdk = __toESM(require("@anthropic-ai/sdk"));
var import_openai = __toESM(require("openai"));
var import_pdf_to_img = require("pdf-to-img");

// src/cropImage.ts
var { createCanvas, loadImage } = require("@napi-rs/canvas");
var sizeOf = require("buffer-image-size");
function cropImage(image) {
  return __async(this, null, function* () {
    const { width, height } = sizeOf(image);
    const img = yield loadImage(image);
    const canvas = createCanvas(width, height);
    const context = canvas.getContext("2d");
    context.drawImage(img, 0, 0);
    const data = context.getImageData(0, 0, width, height).data;
    const top = scanY(true);
    const bottom = scanY(false);
    const left = scanX(true);
    const right = scanX(false);
    if (top === null || bottom === null || left === null || right === null) {
      console.error("image is empty");
      return canvas.toDataURL();
    }
    const new_width = right - left;
    const new_height = bottom - top;
    canvas.width = new_width;
    canvas.height = new_height;
    context.drawImage(
      img,
      left,
      top,
      new_width,
      new_height,
      0,
      0,
      new_width,
      new_height
    );
    return canvas.toDataURL();
    function getRGB(x, y) {
      return {
        red: data[(width * y + x) * 4],
        green: data[(width * y + x) * 4 + 1],
        blue: data[(width * y + x) * 4 + 2]
      };
    }
    function isColor(rgb) {
      return rgb.red == 255 && rgb.green == 255 && rgb.blue == 255;
    }
    function scanY(top2) {
      var offset = top2 ? 1 : -1;
      for (var y = top2 ? 0 : height - 1; top2 ? y < height : y > -1; y += offset) {
        for (var x = 0; x < width; x++) {
          if (!isColor(getRGB(x, y))) {
            return y;
          }
        }
      }
      return null;
    }
    function scanX(left2) {
      const offset = left2 ? 1 : -1;
      for (let x = left2 ? 0 : width - 1; left2 ? x < width : x > -1; x += offset) {
        for (let y = 0; y < height; y++) {
          if (!isColor(getRGB(x, y))) {
            return x;
          }
        }
      }
      return null;
    }
  });
}

// src/index.ts
var dJSON = require("dirty-json");
var PageOptions = /* @__PURE__ */ ((PageOptions2) => {
  PageOptions2["ALL"] = "ALL";
  PageOptions2["FIRST"] = "FIRST";
  PageOptions2["LAST"] = "LAST";
  PageOptions2["FIRST_AND_LAST"] = "FIRST_AND_LAST";
  return PageOptions2;
})(PageOptions || {});
var DocumentOcr = class {
  constructor({
    apiKey = process.env.OPENAI_API_KEY,
    model = "gpt-4-turbo",
    standardFontDataUrl = "https://unpkg.com/pdfjs-dist@3.2.146/standard_fonts/",
    debug = false
  }) {
    this.process = (_0) => __async(this, [_0], function* ({
      document,
      mimeType,
      prompt,
      pageOptions = "ALL" /* ALL */,
      multiplePasses = false
    }) {
      if (this.debug) {
        console.time("process");
      }
      if (typeof document === "string" && document.indexOf(",") > 0) {
        if (this.debug)
          console.log("Removing data:xxx/xxx;base64, prefix");
        document = document.split(",")[1];
      }
      const buffer = Buffer.isBuffer(document) ? document : Buffer.from(document, "base64");
      const imageData = [];
      if (mimeType === "application/pdf") {
        if (this.debug)
          console.log("Converting PDF to images");
        try {
          const pdfPages = yield (0, import_pdf_to_img.pdf)(buffer, {
            scale: 2,
            docInitParams: {
              disableFontFace: true,
              standardFontDataUrl: this.standardFontDataUrl
            }
          });
          if (this.debug) {
            console.log(
              `PDF has ${pdfPages.length} pages. Converting to images.`
            );
          }
          const numPages = pdfPages.length;
          let currentPage = 0;
          try {
            for (var iter = __forAwait(pdfPages), more, temp, error; more = !(temp = yield iter.next()).done; more = false) {
              const page = temp.value;
              if (pageOptions === "FIRST" /* FIRST */ || pageOptions === "FIRST_AND_LAST" /* FIRST_AND_LAST */) {
                if (currentPage === 0) {
                  imageData.push(page);
                }
              }
              if (pageOptions === "LAST" /* LAST */ || pageOptions === "FIRST_AND_LAST" /* FIRST_AND_LAST */) {
                if (currentPage === numPages - 1) {
                  imageData.push(page);
                }
              }
              if (pageOptions === "ALL" /* ALL */) {
                imageData.push(page);
              }
              currentPage++;
            }
          } catch (temp) {
            error = [temp];
          } finally {
            try {
              more && (temp = iter.return) && (yield temp.call(iter));
            } finally {
              if (error)
                throw error[0];
            }
          }
        } catch (e) {
          console.error(e);
        }
      } else {
        imageData.push(buffer);
      }
      let content = "";
      if (this.model.startsWith("gpt-4")) {
        content = yield useOpenAI({
          model: this.model,
          imageData,
          prompt,
          debug: this.debug,
          apiKey: this.apiKey
        });
      } else if ([
        "claude-3-opus-20240229",
        "claude-3-sonnet-20240229",
        "claude-3-haiku-20240307"
      ].includes(this.model)) {
        if (mimeType === "application/pdf") {
          mimeType = "image/png";
        } else if (mimeType === "image/jpg") {
          mimeType = "image/jpeg";
        }
        content = yield useAnthropic({
          imageData,
          prompt,
          debug: this.debug,
          apiKey: this.apiKey,
          mimeType,
          model: this.model
        });
      }
      if (this.debug) {
        console.log("Raw LLM Response: ");
        console.log(content);
      }
      content = content.replace("```json", "");
      content = content.replace("```", "");
      content = content.replace(/(?:\r\n|\r|\n)/g, "");
      content = content.replace(/(^,)|(,$)/g, "");
      const out = dJSON.parse(content != null ? content : "{}");
      if (this.debug) {
        console.log("Cleaned LLM Response: ");
        console.log(JSON.stringify(out, null, 2));
        console.timeEnd("process");
      }
      return out;
      function useOpenAI(_02) {
        return __async(this, arguments, function* ({
          imageData: imageData2,
          prompt: prompt2,
          debug,
          model,
          apiKey
        }) {
          var _a;
          const imageGPTArray = yield Promise.all(
            imageData2.map((image) => __async(this, null, function* () {
              const message = {
                type: "image_url",
                image_url: {
                  url: yield cropImage(image)
                }
              };
              return message;
            }))
          );
          if (debug) {
            console.log({
              prompt: prompt2
            });
          }
          const openai = new import_openai.default({
            apiKey
          });
          const response = yield openai.chat.completions.create({
            model,
            response_format: {
              type: model === "gpt-4-vision-preview" ? "text" : "json_object"
            },
            max_tokens: 4096,
            temperature: 0,
            messages: [
              {
                role: "system",
                content: "Find: " + prompt2 + "\nRespond with a valid JSON object with all numbers as a string an no additional text or characters."
              },
              {
                role: "user",
                content: [...imageGPTArray]
              }
            ]
          });
          return (_a = response.choices[0].message.content) != null ? _a : "";
        });
      }
      function useAnthropic(_02) {
        return __async(this, arguments, function* ({
          imageData: imageData2,
          prompt: prompt2,
          debug,
          model = "claude-3-haiku-20240307",
          apiKey,
          mimeType: mimeType2
        }) {
          var _a, _b, _c;
          const imageGPTArray = yield Promise.all(
            imageData2.map((image) => __async(this, null, function* () {
              const message = {
                type: "image",
                source: {
                  type: "base64",
                  media_type: mimeType2,
                  data: (yield cropImage(image)).split(",")[1]
                }
              };
              return message;
            }))
          );
          if (debug) {
            console.log({
              prompt: prompt2
            });
          }
          const anthropic = new import_sdk.default({
            apiKey
          });
          let extractedText = "";
          if (multiplePasses) {
            const ocr = yield anthropic.messages.create({
              model: "claude-3-haiku-20240307",
              max_tokens: 4096,
              temperature: 0,
              messages: [
                {
                  role: "user",
                  content: [
                    {
                      type: "text",
                      text: "Extract all data including unlabeled fields"
                    },
                    ...imageGPTArray
                  ]
                }
              ]
            });
            if (debug) {
              console.log((_a = ocr.content[0].text) != null ? _a : "");
            }
            extractedText = (_b = ocr.content[0].text) != null ? _b : "";
          }
          const response = yield anthropic.messages.create({
            model,
            max_tokens: 4096,
            temperature: 0,
            messages: [
              {
                role: "user",
                content: [
                  ...imageGPTArray,
                  {
                    type: "text",
                    text: `${extractedText}
Find: ` + prompt2 + "\nRespond with a valid JSON object with all numbers as a string an no additional text or characters and if not provided, return null."
                  }
                ]
              }
            ]
          });
          return (_c = response.content[0].text) != null ? _c : "";
        });
      }
    });
    if (!apiKey) {
      throw new Error("OCR API Key is not defined");
    }
    this.apiKey = apiKey;
    this.model = model;
    this.standardFontDataUrl = standardFontDataUrl;
    this.debug = debug;
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  DocumentOcr,
  PageOptions
});
//# sourceMappingURL=index.js.map